#include <stdio.h>
#include <stdlib.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <time.h>


#define SAFE_DELETE(p) {if(p!=NULL){delete [] p;p=NULL;}}

int factorial(int n){
	int ret=n,i=n;
	if(n=0)return 1;
	for(i-=1;1<i;i-=1)ret=ret*i;
	return ret;
}
int Binomial(int n,int k){
	int a=factorial(n);
	int b=factorial(n-k);
	int c=factorial(k);
	if(b*c==0)return 1;
	return (a/(b*c));
}
double halftheta(double theta){
	return sqrt((1.0+theta)/2.0);
}
double halfsintheta(double c){
	return sqrt((1.0-c)/2.0);
}
double ntheta(double theta,int n){
	double ret=0.0,a,b;
	int i,j;
	for(i=0;i<=n/2;i++){
		a=pow(-1.0,(double)i)*pow(theta,(double)(n-2*i));
		for(b=0.0,j=i;j<=n/2;j++){
			b+=(double)Binomial(n,2*j)*(double)Binomial(j,i);
		}
		ret+=a*b;
	}
	return ret;
}
double sinntheta(double theta,int n){
	double ret=0.0,s=theta,c=sqrt(1.0-(theta*theta)),a,b;
	int i,j,k;
	for(i=0;i<=(n-1)/2;i++){
		k=2*(((n-1)/2)-i)+1;
		a=pow(-1.0,(double)(((n-1)/2)-i))*pow(s,(double)k);
		for(b=0.0,j=i;j<=(n-1)/2;j++){
			b+=(double)Binomial(n,2*(j-i)+1)*(double)Binomial(((n-1)/2)-(j-i),i);
		}
		ret+=a*b;
	}
	ret*=pow(c,(1.0+pow(-1.0,(double)n))/2.0);
	return ret;
}
double divntheta(double theta,int n){
	double ret=0.0,s=pow(1.0-pow(theta,2.0),0.5);
	ret=sinntheta(s,n);
	return ret;
}

int sweepprime(int **p,int n){
	SAFE_DELETE(*p);
	*p=new int[n];
	int* tmp=new int[n];
	int i,j,k=0;
	for(i=1;i<n;i++)tmp[i]=0;
	for(i=2;i<n;i++){
		if(tmp[i]==0){
			(*p)[k++]=i;
			for(j=i*2;j<n;j+=i)tmp[j]=1;
		}
	}
	SAFE_DELETE(tmp);
	return k;
}


void main(){
/*
	FILE *fp;
	if((fp=fopen("pai.txt","w"))==NULL) return;
	long long int i,j,MAX_N=10000;
	double d,e,DELTA=0.00001;
	for(i=1;i<MAX_N;i++){
		for(j=1;j<MAX_N;j++){
			d=(double)i/(double)j;
			e=d-M_PI;
			if(e<-DELTA)continue;
			else if(e<0.0)e=-e;
			if(e<=DELTA)
			{
				fprintf(fp,"%lld / %lld = %.15lf\n",i,j,d);
			}
		}
	}
	fclose(fp);
*/
//*
	double a,b,c,d,e,tmpa[30],tmpb[30],tmpa2[43],tmpb2[43],DELTA=0.000001;
	int i,j,k,l,m,n,o,MAX_N=30,MAX_P=100,tmp[100];
//*/
/*
	d=M_LN10/10000.0;
	for(b=0.0,a=-10000.0;a<=10000.0;a+=1.0){
		b+=1.0/(pow(10.0,(a/100.0)*(a/100.0)));			
	}
	c=b*b*d;
	printf("%.14lf\n",c);
	printf("\n");
//*/
/*
	FILE* fp;
	fp=fopen("data.txt","w");

	for(a=0.0;a<90.0;a+=0.001){
		c=a*M_PI/180.0;
		d=atan(M_PI*tan(c));
		b=d*180.0/M_PI;
		fprintf(fp,"%lf,%lf\n",a,b);
	}
	fclose(fp);
//*/
/*
	FILE* fp;
	fp=fopen("data.txt","w");

	for(a=10.0;a<1000000000.0;a*=10.0){
	//for(a=4.0;a<100000000.0;a*=2.0){
	//for(a=2048.0;a<4096.0;a+=1.0){
	//for(a=35000000.0;a<40000000.0;a+=1.0){
		b=a*sin(M_PI/a);
		fprintf(fp,"%.15lf,%.15lf\n",a,b);
	}
	fclose(fp);
//*/
/*
	for(a=0.0,i=1;i<MAX_N;i++){
		a+=1.0/(double)(i*i);
	}
	printf("%.15lf\n",a);
	printf("\n");
//*/

	FILE* fp;
	fp=fopen("data.txt","w");
//	fp=fopen("lehman.txt","w");
//*

	fprintf(fp,"######################################cos/(2^n)\n");
	for(a=0.5,b=0.0,c=1.0,i=0;i<MAX_N;i++){
		fprintf(fp,"%.15lf,%.15lf | %.15lf / %.15lf | %.15lf\n",a,b,cos(a*M_PI),c,sin(a*M_PI));
		tmpa[i]=a;
		tmpb[i]=b;
		a*=0.5;
		c=halfsintheta(b);
		b=halftheta(b);
		if(0.02<c){
			d=a;
			e=c;
		}
	}

	fprintf(fp,"######################################\n");
	fprintf(fp,"%.15lf,%.15lf | %.15lf =%.15lf\n",d,e,e*(1.0/d),M_PI);



	fprintf(fp,"######################################cos\n");
	a=0.0;b=1.0;
	fprintf(fp,"%8d %.15lf,%.15lf | %.15lf\n",0,a,b,cos(a*M_PI));

	for(m=0,j=23;0<j;j-=4){
		a=tmpa[j];
		c=b=tmpb[j];
		o=0;
		for(k=0,i=1;i<9;i++,m++){
			if(j==3){
				if(i==1){
					a=tmpa[4];
					b=tmpb[4];
					c=b;
					i++;
					o=1;
					b=ntheta(c,o+i);
				}
				if(i%2==1)i++;
			}
			l=(int)pow(2.0,(double)(23-j));
			fprintf(fp,"%8d %.15lf,%.15lf | %.15lf\n",l+l*k++,a*i,b,cos(a*i*M_PI));
			if(43<=m){n=k;break;}
			tmpa2[m]=a*i;tmpb2[m]=b;			
			b=ntheta(c,o+i+1);
		}
	}

	b=tmpb2[0];
	c=sqrt(1.0-pow(b,2.0));
	for(m=1,i=0;i<43;i++,m++){
		if(8<m){
			m=1;
			b=tmpb2[i];
			c=sqrt(1.0-pow(b,2.0));
		}

		if(35<i){
			m=1;
			b=tmpb2[i];
			c=sqrt(1.0-pow(b,2.0));
		}

		a=0.5-tmpa2[i];
		b=sinntheta(c,m);
		fprintf(fp,"%8d %.15lf,%.15lf | %.15lf\n",i,a,b,sqrt(1.0-pow(sin(a*M_PI),2.0)));
	}
	fprintf(fp,"######################################cosn\n");
	b=a=tmpa[3];
	d=c=tmpb[3];
	for(i=1;i<8;i++){
		b=a*(double)i;
		d=ntheta(c,i);
		fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",i,b,d,cos(b*M_PI));
	}
	fprintf(fp,"######################################sinn\n");
	b=a;
	c=d;
	for(i=1;i<8;i++){
		b=a*(double)i;
		d=sinntheta(c,i);
		fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",i,b,d,sin(b*M_PI));
	}
	fprintf(fp,"######################################cos(/2-n)=sinn\n");
	a=tmpa[3];
	b=0.5-a;
	d=c=sqrt(1.0-tmpb[3]*tmpb[3]);
	for(i=1;i<8;i++){
		b=0.5-a*(double)i;
		d=sinntheta(c,i);
		fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",i,b,d,cos(b*M_PI));
	}
	fprintf(fp,"######################################cosn13{pG[\n");
	b=a=tmpa[4];
	d=c=tmpb[4];
	for(i=1;i<16;i++){
		b=a*(double)i;
		d=ntheta(c,i);
		fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",i,b,d,cos(b*M_PI));
	}
	fprintf(fp,"######################################cos\n");

	a=0.0;b=1.0;
	fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",0,a,b,cos(a*M_PI));

	fprintf(fp,"\n");

	for(j=25;3<j;j-=3){
		b=a=tmpa[j];
		d=c=tmpb[j];
		for(i=1;i<8;i++){
			b=a*(double)i;
			d=ntheta(c,i);
			fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",i,b,d,cos(b*M_PI));
		}
		fprintf(fp,"\n");
	}

	b=a*(double)i;
	d=ntheta(c,i);
	fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",i,b,d,cos(b*M_PI));

	fprintf(fp,"\n");

	for(j=4;j<26;j+=3){
		b=a=tmpa[j];
		d=c=sqrt(1.0-tmpb[j]*tmpb[j]);
		for(i=7;0<i;i--){
			b=0.5-a*(double)i;
			d=sinntheta(c,i);
			fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",8-i,b,d,cos(b*M_PI));
		}
		fprintf(fp,"\n");
	}

	a=0.5;b=0.0;
	fprintf(fp,"%3d %.15lf,%.15lf | %.15lf\n",0,a,b,cos(a*M_PI));

	fprintf(fp,"\n");

//*/

/*
	int *prm=NULL;
	i=sweepprime(&prm,MAX_N);

	fprintf(fp,"%.15lf\n",ans);

	a=1.0;
	for(j=0;j<i;j++){
		b=(double)prm[j];
		c=1.0/(1.0-1.0/b/b);
		a*=c;
		fprintf(fp,"%lf %.15lf | %.15lf\n",b,c,a);
	}

	SAFE_DELETE(prm);
//*/

	
//*	
	k=0;
	i=2;
	tmp[k++]=i;
	for(i=3;i<MAX_P;i+=2){
		for(l=j=0;j<k;j++){
			//if((i%tmp[j])==0){l++;break;}
			a=sin((double)i*M_PI/(double)tmp[j]);
			if(-DELTA<a&&a<DELTA){l++;break;}
		}
		if(l==0){
			tmp[k++]=i;
		}
	}

	fprintf(fp,"######################################prime\n");
	for(j=0;j<k;j++){
		fprintf(fp,"%d\n",tmp[j]);
	}
	
//*/






	fclose(fp);
}
